%define _unpackaged_files_terminate_build 1

Summary: Tool to manage your infrastructure
Name: salt
Version: 3007.0
Release: alt1
Url: http://saltstack.org
#VCS: https://github.com/saltstack/salt
License: Apache-2.0
Group: System/Configuration/Other

Packager: Andrey Cherepanov <cas@altlinux.org>

BuildArch: noarch

Source0: %name-%version.tar
Source1: master.logrotate
Source2: minion.logrotate
Source3: salt-api.init
Source4: salt-master.init
Source5: salt-minion.init
Source6: salt-syndic.init

Patch1: salt-alt-supported-names.patch
Patch2: salt-alt-uname-path.patch

BuildRequires(pre): rpm-build-python3
BuildRequires: python3-module-setuptools perl-podlators
BuildRequires: libzeromq-devel
BuildRequires: python3-module-msgpack python3-module-yaml
BuildRequires: python3-module-distro
BuildRequires: python3-module-wheel
BuildRequires: python3-module-importlib-metadata

# Control module version for 3006.6
BuildRequires: python3-module-cryptography >= 41.0.7
BuildRequires: python3-module-urllib3 >= 2.0.6
BuildRequires: python3-module-pycryptodome >= 3.19.1
BuildRequires: python3-module-pycryptodomex >= 3.19.1
BuildRequires: python3-module-GitPython >= 3.1.41
BuildRequires: python3-module-jinja2 >= 3.1.3

%add_python3_req_skip win32api win32event win32service win32serviceutil winerror pythoncom distutils ntsecuritycon win32con win32process win32security vsanmgmtObjects requests.packages.urllib3.util.ssl_

# pyrax.exceptions is a not a real dependency: pyrax
# presence is gated at salt/utils/openstack/pyrax/__init__.py
%add_python3_req_skip pyrax.exceptions

# For more detailed autoreqs (under jnpr.*), which can be satisfied;
# this fixes the general UNMET python2.X(jnpr), which used to appear.
%python3_req_hier
# except "virtual" Provides of six.py, which cannot be autogenerated:
# {0} is to strip a space at the end:
%filter_from_requires s:salt\.ext\.::g
%filter_from_requires \,\(/sbin/chkconfig\|/usr/bin/easy_install-2\.7\|/usr/bin/pip\|apt\|curl\|erlang\|ftp\|gawk\|git-core\|grep\|initctl\|local/s*bin\|lxc\|make\|perl-Package\|python-base\|python2-base\|python-module-setuptools\|python-module-virtualenv\|rpm\|salt-minion\|salt-key\|service\|sudo\|systemctl\|systemd\|wget\|yum-config-manager\|rc-update\|/bin/launchctl\|/usr/sbin/installer\|python2\|yum\|dnf\|pacman\|/usr/bin/kstat\),d

%description
Salt is a distributed remote execution system used to execute commands
and query data. It was developed in order to bring the best solutions
found in the world of remote execution together and make them better,
faster and more malleable. Salt accomplishes this via its ability to
handle larger loads of information, and not just dozens, but hundreds,
or even thousands of individual servers. It handles them quickly and
through a simple yet manageable interface.

%package -n python3-module-salt
Summary: Management component for salt, a parallel remote execution system
Group: Development/Python
Obsoletes: python-module-salt 
%py3_requires yaml msgpack pycryptodomex contextvars

%description  -n python3-module-salt
Salt is a distributed remote execution system used to execute commands
and query data. It was developed in order to bring the best solutions
found in the world of remote execution together and make them better,
faster and more malleable. Salt accomplishes this via its ability to
handle larger loads of information, and not just dozens, but hundreds,
or even thousands of individual servers. It handles them quickly and
through a simple yet manageable interface.

%package master
Summary: Management component for salt, a parallel remote execution system
Group: System/Configuration/Other
Requires: python3-module-salt = %version-%release

%description master
The Salt master is the central server to which all minions connect.

%package minion
Summary: Client component for salt, a parallel remote execution system
Group: System/Configuration/Other
Requires: python3-module-salt = %version-%release

%description minion
Salt minion is queried and controlled from the master.

%package api
Summary: API for salt
Group: System/Configuration/Other
Requires: python3-module-salt = %version-%release

%description api
salt-api is a modular interface on top of Salt that can provide
a variety of entry points into a running Salt system. It can start
and manage multiple interfaces allowing a REST API to coexist
with XMLRPC or even a Websocket API.

%prep
%setup
%patch1 -p1
%patch2 -p1
# Current Salt version from sources
echo -n '%version' > salt/_version.txt
# Remove local copy documentation mention
subst 's| file:///usr/share/doc/salt/html/contents.html||' pkg/common/*.service
# Proper sysctl -w use: http://bugzilla.altlinux.org/47289
sed -i 's/_sysctl, "-w"/_sysctl, "-v", "-w"/' salt/modules/linux_sysctl.py

%build
%pyproject_build

%install
%pyproject_install

# Add some directories
install -d -m 0755 %buildroot%_var/log/salt
touch %buildroot%_var/log/salt/minion
touch %buildroot%_var/log/salt/master
install -d -m 0755 %buildroot%_var/cache/salt
install -d -m 0755 %buildroot%_sysconfdir/salt
install -d -m 0755 %buildroot%_sysconfdir/salt/master.d
install -d -m 0755 %buildroot%_sysconfdir/salt/minion.d
install -d -m 0755 %buildroot%_sysconfdir/salt/pki
install -d -m 0755 %buildroot%_sysconfdir/salt/pki/master
install -d -m 0755 %buildroot%_sysconfdir/salt/pki/minion
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.conf.d
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.deploy.d
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.maps.d
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.profiles.d
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.providers.d
install -d -m 0755 %buildroot%_sysconfdir/salt/proxy.d

install -D -m 755 %SOURCE4 %buildroot%_initdir/salt-master
install -D -m 755 %SOURCE6 %buildroot%_initdir/salt-syndic
install -D -m 755 %SOURCE5 %buildroot%_initdir/salt-minion
install -D -m 755 %SOURCE3 %buildroot%_initdir/salt-api

mkdir -p %buildroot%_unitdir
install -p -m 0644 pkg/common/salt-master.service %buildroot%_unitdir/
install -p -m 0644 pkg/common/salt-syndic.service %buildroot%_unitdir/
install -p -m 0644 pkg/common/salt-minion.service %buildroot%_unitdir/
install -p -m 0644 pkg/common/salt-api.service %buildroot%_unitdir/
install -p -m 0644 pkg/common/salt-proxy@.service %buildroot%_unitdir/

mkdir -p %buildroot%_sysconfdir/salt/
install -p -m 0640 conf/minion %buildroot%_sysconfdir/salt/minion
install -p -m 0640 conf/master %buildroot%_sysconfdir/salt/master
install -p -m 0640 conf/cloud  %buildroot%_sysconfdir/salt/cloud
install -p -m 0640 conf/roster %buildroot%_sysconfdir/salt/roster
install -p -m 0640 conf/proxy  %buildroot%_sysconfdir/salt/proxy

mkdir -p %buildroot%_sysconfdir/sysconfig
echo "ARG=''" >  %buildroot%_sysconfdir/sysconfig/salt-master
echo "ARG=''" >  %buildroot%_sysconfdir/sysconfig/salt-syndic
echo "ARG=''" >  %buildroot%_sysconfdir/sysconfig/salt-minion
echo "ARG=''" >  %buildroot%_sysconfdir/sysconfig/salt-api

install -D -m 0644 pkg/common/salt.bash %buildroot%_sysconfdir/bash_completion.d/salt

install -D -m 0644 %SOURCE1 %buildroot%_sysconfdir/logrotate.d/salt-master
install -D -m 0644 %SOURCE2 %buildroot%_sysconfdir/logrotate.d/salt-minion

%post master
%post_service salt-master
%post_service salt-syndic

%preun master
%preun_service salt-master
%preun_service salt-syndic

%post minion
%post_service salt-minion

%preun minion
%preun_service salt-minion

%post api
%post_service salt-api

%preun api
%preun_service salt-api

%files -n python3-module-salt
%doc AUTHORS README*
%config(noreplace) %dir %_sysconfdir/salt
%config(noreplace) %dir %_sysconfdir/salt/pki
%python3_sitelibdir/*
%_man7dir/salt.7.*

%files master
%config(noreplace) %_sysconfdir/salt/master
%config(noreplace) %_sysconfdir/salt/master.d
%config(noreplace) %_sysconfdir/salt/roster
%config %_sysconfdir/bash_completion.d/*
%config(noreplace) %dir %_sysconfdir/bash_completion.d
%config(noreplace) %_sysconfdir/logrotate.d/salt-master
%config(noreplace) %_sysconfdir/salt/pki/master
%config(noreplace) %_sysconfdir/sysconfig/salt-master
%config(noreplace) %_sysconfdir/sysconfig/salt-syndic
%_sysconfdir/salt/cloud.conf.d
%_sysconfdir/salt/cloud.deploy.d
%_sysconfdir/salt/cloud.maps.d
%_sysconfdir/salt/cloud.profiles.d
%_sysconfdir/salt/cloud.providers.d
%config(noreplace) %_sysconfdir/salt/cloud
%ghost %_logdir/salt/master
%_var/cache/salt
%_initdir/salt-master
%_initdir/salt-syndic
%_unitdir/salt-master.service
%_unitdir/salt-syndic.service
%_bindir/salt
%_bindir/salt-cloud
%_bindir/salt-cp
%_bindir/salt-key
%_bindir/salt-master
%_bindir/salt-pip
%_bindir/salt-run
%_bindir/salt-ssh
%_bindir/salt-syndic
%_bindir/spm
%_man1dir/salt.1.*
%_man1dir/salt-master.1.*
%_man1dir/salt-cp.1.*
%_man1dir/salt-cloud.1.*
%_man1dir/salt-key.1.*
%_man1dir/salt-run.1.*
%_man1dir/salt-syndic.1.*
%_man1dir/salt-ssh.1.*
%_man1dir/spm.1.*

%files api
%config(noreplace) %_sysconfdir/sysconfig/salt-api
%_bindir/salt-api
%_initdir/salt-api
%_unitdir/salt-api.service
%_man1dir/salt-api.1.*

%files minion
%config(noreplace) %_sysconfdir/salt/minion
%config(noreplace) %_sysconfdir/salt/minion.d
%config(noreplace) %_sysconfdir/salt/proxy
%config(noreplace) %_sysconfdir/logrotate.d/salt-minion
%config(noreplace) %_sysconfdir/sysconfig/salt-minion
%config(noreplace) %_sysconfdir/salt/pki/minion
%ghost %_logdir/salt/minion
%_initdir/salt-minion
%_unitdir/salt-minion.service
%_unitdir/salt-proxy@.service
%_bindir/salt-call
%_bindir/salt-minion
%_bindir/salt-proxy
%_man1dir/salt-call.1.*
%_man1dir/salt-minion.1.*
%_man1dir/salt-proxy.1.*

%changelog
* Sat Mar 09 2024 Andrey Cherepanov <cas@altlinux.org> 3007.0-alt1
- New version.

* Wed Feb 28 2024 Andrey Cherepanov <cas@altlinux.org> 3006.7-alt1
- New version.

* Wed Feb 14 2024 Andrey Cherepanov <cas@altlinux.org> 3006.6-alt1
- New version.
- Security fixes:
  + CVE-2024-22231 Prevent directory traversal when creating syndic cache
    directory on the master.
  + CVE-2024-22232 Prevent directory traversal attacks in the master's
    serve_file method.

* Thu Nov 02 2023 Andrey Cherepanov <cas@altlinux.org> 3006.4-alt1
- New version.
- Security fix for CVE-2023-34049.

* Sun Oct 15 2023 Michael Shigorin <mike@altlinux.org> 3006.3-alt3.2
- Fix weird Requires: of bootstrap-salt.sh.

* Sun Oct 15 2023 Michael Shigorin <mike@altlinux.org> 3006.3-alt3.1
- Fix flaky sysctl -w use (closes: #47289; thx Vladimir Mokrozub).

* Mon Sep 18 2023 Andrey Cherepanov <cas@altlinux.org> 3006.3-alt3
- Remove autorequirement of salt-sater from python3-module-salt.

* Tue Sep 12 2023 Andrey Cherepanov <cas@altlinux.org> 3006.3-alt2
- Added missing CVE-2023-20897 and CVE-2023-20898 for 3006.2.

* Sat Sep 09 2023 Andrey Cherepanov <cas@altlinux.org> 3006.3-alt1
- New version.

* Tue Aug 15 2023 Andrey Cherepanov <cas@altlinux.org> 3006.2-alt1
- New version.

* Thu Jun 15 2023 Andrey Cherepanov <cas@altlinux.org> 3006.1-alt1
- New version.

* Tue Apr 25 2023 Andrey Cherepanov <cas@altlinux.org> 3006.0-alt1
- New version.

* Tue Apr 11 2023 Anton Vyatkin <toni@altlinux.org> 3005.1-alt4
- Fix BuildRequires

* Sat Jan 21 2023 Andrey Cherepanov <cas@altlinux.org> 3005.1-alt3
- Fixed salt-3005.1-version.patch applying.

* Sat Jan 21 2023 Andrey Cherepanov <cas@altlinux.org> 3005.1-alt2
- Used %%pyproject_build andf %%pyproject_install.
- Fixed version in metadata.
- Applied patch only for python3-module-importlib-metadata 5.0.0+

* Thu Jan 19 2023 Andrey Cherepanov <cas@altlinux.org> 3005.1-alt1
- New version.

* Wed Nov 23 2022 Andrey Cherepanov <cas@altlinux.org> 3004.2-alt2
- Removed internal contextvars from runtime requirements.

* Mon Nov 21 2022 Andrey Cherepanov <cas@altlinux.org> 3004.2-alt1
- New version.
- Security fixes: CVE-2022-22967, CVE-2022-22941, CVE-2022-22936,
  CVE-2022-22935, CVE-2022-22934.

* Sun Nov 13 2022 Daniel Zagaynov <kotopesutility@altlinux.org> 3004-alt4.1
- NMU: used %%add_python3_self_prov_path macro to skip self-provides from dependencies.

* Mon Jul 25 2022 Andrey Cherepanov <cas@altlinux.org> 3004-alt4
- Removed pacman from autorequirements.

* Sat Jun 18 2022 Andrey Cherepanov <cas@altlinux.org> 3004-alt3
- Use Jinja2 3.1.0 (ALT #43012).

* Tue Apr 05 2022 Andrey Cherepanov <cas@altlinux.org> 3004-alt2
- Fix build for Python 3.10.
- Remove yum from autorequirements.

* Mon Oct 18 2021 Andrey Cherepanov <cas@altlinux.org> 3004-alt1
- New version.
- Security fixes: CVE-2021-22004, CVE-2021-21996.

* Wed Oct 06 2021 Ivan A. Melnikov <iv@altlinux.org> 3003.2-alt2
- Skip pyrax.exceptions dependency (fixes build on mipsel)

* Fri Sep 24 2021 Andrey Cherepanov <cas@altlinux.org> 3003.2-alt1
- New version.

* Thu Jun 24 2021 Andrey Cherepanov <cas@altlinux.org> 3003.1-alt1
- New version.
- Security fixes: CVE-2021-31607

* Fri Apr 02 2021 Andrey Cherepanov <cas@altlinux.org> 3003-alt2
- Fixed: CVE-2020-28243, CVE-2020-28972, CVE-2020-35662, CVE-2021-3148,
  CVE-2021-3144, CVE-2021-25281, CVE-2021-25282, CVE-2021-25283,
  CVE-2021-25284, CVE-2021-25315, CVE-2021-3197, CVE-2020-16846,
  CVE-2020-17490, CVE-2020-25592

* Thu Apr 01 2021 Andrey Cherepanov <cas@altlinux.org> 3003-alt1
- New version.

* Wed Mar 10 2021 Andrey Cherepanov <cas@altlinux.org> 3002.5-alt1
- New version.

* Thu Nov 19 2020 Andrey Cherepanov <cas@altlinux.org> 3002.2-alt1
- New version.

* Thu Oct 22 2020 Andrey Cherepanov <cas@altlinux.org> 3002-alt1
- New version.

* Tue Aug 25 2020 Andrey Cherepanov <cas@altlinux.org> 3001.1-alt1
- New version.
- Use python3-module-pycryptodomex instead of python3-module-pycrypto.

* Fri May 08 2020 Andrey Cherepanov <cas@altlinux.org> 3000.2-alt1
- New version.
- Remove local copy documentation mention in service files.
- Fix build with Python 3.8.
- Improve detection of ALT distro.
- Fixes:
  + CVE-2020-11651
  + CVE-2020-11652

* Sat Apr 04 2020 Andrey Cherepanov <cas@altlinux.org> 3000.1-alt1
- New version.

* Wed Feb 12 2020 Andrey Cherepanov <cas@altlinux.org> 3000-alt1
- New version.

* Mon Sep 23 2019 Anton Farygin <rider@altlinux.ru> 2019.8-alt2
- build with python-3

* Thu Jul 18 2019 Andrey Cherepanov <cas@altlinux.org> 2019.8-alt1
- New version.
- Drop python-module-salt-tests missing in upstream.

* Mon Feb 25 2019 Andrey Cherepanov <cas@altlinux.org> 2019.2.0-alt1
- New version.

* Wed Jan 09 2019 Andrey Cherepanov <cas@altlinux.org> 2019.2-alt1
- New version.

* Mon Sep 17 2018 Andrey Cherepanov <cas@altlinux.org> 2018.11-alt1
- New version.

* Fri Jun 22 2018 Andrey Cherepanov <cas@altlinux.org> 2018.3.2-alt1
- New version.

* Fri Jun 08 2018 Andrey Cherepanov <cas@altlinux.org> 2018.3.1-alt1
- New version.

* Mon Apr 02 2018 Andrey Cherepanov <cas@altlinux.org> 2018.3.0-alt1
- New version.

* Sat Feb 24 2018 Andrey Cherepanov <cas@altlinux.org> 2018.3-alt1
- New version.

* Wed Dec 13 2017 Andrey Cherepanov <cas@altlinux.org> 2018.2-alt1
- New version.

* Wed Aug 16 2017 Andrey Cherepanov <cas@altlinux.org> 2017.7.1-alt1
- New version

* Thu Jul 13 2017 Andrey Cherepanov <cas@altlinux.org> 2017.7.0-alt1
- New version

* Thu Jun 15 2017 Andrey Cherepanov <cas@altlinux.org> 2017.7-alt1
- New version

* Fri Apr 07 2017 Andrey Cherepanov <cas@altlinux.org> 2017.5-alt1
- New version

* Thu Mar 30 2017 Andrey Cherepanov <cas@altlinux.org> 2016.11.3-alt1
- New version
- Remove optional external executables from autoreq

* Mon Feb 27 2017 Andrey Cherepanov <cas@altlinux.org> 2016.11.1-alt1
- New version 2016.11.1
- Package new files and directories
- Restore init and logrotate files

* Fri Nov 18 2016 Lenar Shakirov <snejok@altlinux.ru> 2016.3.4-alt1
- 2016.3.4

* Thu Sep 08 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2016.3.3-alt4
- Add extra dependiens because master won't start

* Thu Sep 08 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2016.3.3-alt3
- Rebuild with last commits from develop branch

* Thu Sep 08 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2016.3.3-alt2
- Rebuild with new python-module-tornado
- (previous version of tornado was without file locks.py)

* Fri Sep 02 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2016.3.3-alt1
- New version (ALT 32464)

* Thu Jun 16 2016 Ivan Zakharyaschev <imz@altlinux.org> 2015.8.7-alt2
- %%python_req_hier -- for more detailed autoreqs (under jnpr.*),
  without the general UNMET python2.X(jnpr).

* Mon Feb 29 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.8.7-alt1
- New version

* Mon Aug 31 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.5.5-alt1
- New version

* Fri May 29 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.5.1-alt3
- New version

* Sat Apr 18 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.2-alt3
- Removed code from previous tag (ALT 30929)

* Thu Feb 12 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.2-alt2
- Add subpackage python-module-salt-tests

* Mon Feb 02 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.2-alt1
- New version

* Wed Dec 10 2014 Valentin Rosavitskiy <valintinr@altlinux.org> 2014.7-alt3
- Add subpackage salt-api

* Mon Nov 03 2014 Valentin Rosavitskiy <valintinr@altlinux.org> 2014.7-alt2
- Fix repocop info symlink-extra-slash

* Tue Oct 28 2014 Valentin Rosavitskiy <valintinr@altlinux.org> 2014.7-alt1
- New version

* Tue May 13 2014 Valentin Rosavitskiy <valintinr@altlinux.org> 0.17.5-alt1
- New version

* Fri Jan 10 2014 Slava Dubrovskiy <dubrsl@altlinux.org> 0.17.4-alt1
- New version

* Sun Nov 24 2013 Slava Dubrovskiy <dubrsl@altlinux.org> 0.17.2-alt1
- New version

* Sat Sep 28 2013 Slava Dubrovskiy <dubrsl@altlinux.org> 0.17.0-alt1
- New version

* Wed Jan 02 2013 Slava Dubrovskiy <dubrsl@altlinux.org> 0.11.1-alt3
- Update spec
- Fix init scripts

* Mon Dec 24 2012 Slava Dubrovskiy <dubrsl@altlinux.org> 0.11.1-alt2
- New version

* Thu Dec 06 2012 Slava Dubrovskiy <dubrsl@altlinux.org> 0.10.5-alt1
- Build for ALT
